#define pio 2
#define cloudscale 5.1
#define speed 0.02
#define clouddark 0.2
#define cloudlight 0.7
#define cloudcover 0.2
#define cloudalpha 2.0
#define skytint .7
const mat2 m = mat2( 1.6,  1.2, -1.2,  1.6 );

#ifndef PioDiamond
 #define PioDiamond
#endif

highp vec2 hash( highp vec2 p ) {
	p = vec2(dot(p,vec2(127.1,311.7)), dot(p,vec2(269.5,183.3)));
	return -1.0 + 2.0*fract(sin(p)*43758.5453123);
}

highp float noise( highp  vec2 p ) {
    const float K1 = 0.366025404; // (sqrt(3)-1)/2;
    const float K2 = 0.211324865; // (3-sqrt(3))/6;
	highp vec2 i = floor(p + (p.x+p.y)*K1);
    highp vec2 a = p - i + (i.x+i.y)*K2;
    highp vec2 o = (a.x>a.y) ? vec2(1.0,0.0) : vec2(0.0,1.0); //vec2 of = 0.5 + 0.5*vec2(sign(a.x-a.y), sign(a.y-a.x));
    highp vec2 b = a - o + K2;
	highp vec2 c = a - 1.0 + 2.0*K2;
    highp vec3 h = max(0.5-vec3(dot(a,a), dot(b,b), dot(c,c) ), 0.0 );
	highp vec3 n = h*h*h*h*vec3( dot(a,hash(i+0.0)), dot(b,hash(i+o)), dot(c,hash(i+1.0)));
    return dot(n, vec3(70.0));
}

highp float fbm( highp vec2 n ) {
	highp float total = 0.0, amplitude = 0.1;
	for (int i = 0; i < pio; i++) {
		total += noise(n) * amplitude;
		n = m * n;
		amplitude *= 0.4;
	}
	return total;
}

highp vec3 clouds( highp vec2 uv, vec3 fc ){
  highp vec2 p = uv;
  highp float time = TIME * speed;
   highp float q = fbm(uv * cloudscale * 1.8);

    //noise shape
	 highp float f = 0.0;
	 uv *= cloudscale;
    uv -= q - time;
    float weight = 0.2;
    for (int i=0; i<pio; i++){
		f += weight*noise( uv );
        uv = m*uv + time;
		weight *= 0.6;
    }
    
    highp float c = f;

    vec3 skycolour = fc;
    highp vec3 cloudcolour = vec3(1., 1., 1.) * clamp((clouddark + cloudlight*c), 0.0, 1.0);

    f = cloudcover + cloudalpha * 	f;

    return mix(skycolour, clamp(skytint * skycolour + cloudcolour, 0.0, 1.0), clamp(f + c, 0.0, 1.0));
}