
vec4 pio_magic(vec4 w){
if( color.r >= color.b  && color.a >= .95){
  vec4 sb = texture2D( TEXTURE_0, uv0 + vec2( .00005 ));
  sb -= texture2D( TEXTURE_0, uv0 - vec2( .00005 ));
  w += dot( w, sb ) * w;
}
  return w;
}

vec3 sEffect(vec3 c){
 return c;
}

float shadow_leaves(){
float sL = 1.;
#ifdef ALPHA_TEST
 if(color.a > 0. && color.g > color.b 
     && uv0.y > uv0.x*2.5 && uv0.y <= uv0.x*5.
     && uv1.y > .87){
  sL -= max( 1. -( fract( position.y ) * 5.), 0.) * .35 * ( 1. -uv1.x ) * (1. -max(deteksi.hujan, deteksi.malam));
}
#endif

return sL;
}

float shadows_block(){
float s = 1.;
if( uv1.y < .87 ) {
 for(float i = 0.; i < 10.; i++){
   if( uv1.y < (.87 - i * .002) ) s -= i * .005;
 }
}
 return mix(
      mix( s, pow(s, .3) , uv1.x), 1., 
      max( deteksi.hujan, deteksi.malam )
 );
}

float shadow_sisi(){
if( uv1.y >= .87 ) {
float sShadow = 1., sS = color.r;
float grass = .4, water = .1, 
         stone = fract(position.y) == 0. ? .8 : .5;
float cekBlock = ( color.r == color.b && color.b == color.g ) ? stone : grass;
cekBlock = ( color.b * 2. > color.r + color.g ) ? water : cekBlock;
if ( color.a == .0 ) sS *= 10.;
if ( deteksi.malam < .5 && deteksi.hujan < .5 ) {
   for( float i = 0.; i < 10.; i++ ){
     if( sS < ( cekBlock - i * .002 ) ) sShadow -= i * .005;
   }
   sShadow = mix( sShadow, 1., max( deteksi.hujan, deteksi.malam ) );
   sShadow = mix( sShadow, 1., uv1.x );
}
return sShadow;
}
return 1.;
}

float pDles( vec2 uv ){
if( fract(position.y) == 0. && deteksi.hujan > .4 ){
	//float area = clamp(1.-length(uv*2. -1.), .0, 1.);
	float area = clamp(length(uv/8.-1.)*.8, 0., 1.);
	float puddles = clamp(noise(uv*.4), 0., 1.);
  puddles *= .3*(deteksi.hujan-.4)*uv1.y;
	return mix(puddles, 0., area);
}
  return 0.;
}

highp float cSplash(vec2 uv, float s){
	float tes = distance(uv, vec2(.5));
	highp float t   = tan(TIME + s * 2.) * .1;
	highp float area = normalize(max(.13 -tes, .0));
	highp float splash= normalize(max(t -tes, 0.));
	splash -= normalize(max(t -.01 -tes, 0.));
	return mix(splash, 0., 1.-area);
}

highp float rSplash(vec2 uv, float s){
	 highp float c = cSplash(uv, s);
	 c = max(cSplash(uv, s -.25), c);
	 return c;
}

highp float pSplash(vec2 uv){
if( fract(position.y) == 0. && deteksi.hujan > .7 && uv1.y > .85 ){
	highp float p = rSplash(uv, 0.);
	p = max(rSplash(uv +.25, -2.), p);
	p = max(rSplash(uv -2., -1.), p);
	p = max(rSplash(uv -vec2(0.,0.3), 1.), p);
	p = max(rSplash(uv +vec2(0.5,-0.5), .5), p);
	p = max(rSplash(uv -vec2(0.5,-0.5), .5), p);
	p = max(rSplash(uv -.5, .5), p);
	p = max(rSplash(uv +.5, .5), p);
	p = max(rSplash(uv +vec2(0.35,0.2), -.5), p);
	p = max(rSplash(uv -vec2(0.35,0.2), 1.5), p);

	return ( p * .3 + .1 ) * (deteksi.hujan-.7) * 2.;
}
return 0.;
}

vec3 Pio_Color(vec3 c){
if( ( color.r == color.b && color.r == color.g ) || color.a == 0. ) {
 c = Uncharted2ToneMapping(c) * 1.3;
}
if( FOG_CONTROL.x == 0. ){
 c *= max( .5, 1. -deteksi.malam );
}
return c;
}

float inrect(vec2 pos, float x1, float y1, float x2, float y2, float focus){
 return min(1.0, max(min(min(pos.x - x1, x2 - pos.x), min(pos.y - y1, y2 - pos.y)), 0.0) / focus);
}

//setLightWorld
vec4 dLight(vec2 uvl){
  uvl.x = mix( 1., uvl.x, clamp(length(-look) / RENDER_DISTANCE * 15., 0., 1. ));
  vec4 setLightWorld = texture2D( TEXTURE_1, uvl );
  setLightWorld += mix(vec4( .1, .05, -.05, .3 ) * uvl.x, vec4(0.), uv1.x);
  return setLightWorld;
}

float pShadow(){
vec3 lookvector=look;
lookvector.x*=2.0;
 vec3 pos = lookvector + vec3(0.4, 0.4, 0.4); 
 vec3 dir = vec3(-1.0, (1.25) * 0.31, 0.0);
 float factor = 1.0;
 if (pos.x < 0.2){
  factor = max(0.0, pos.x / 0.4 + 0.5);
 }
pos += dir * pos.x;
 float focus = .04;
 float footwalk = sin((position.x - lookvector.x) * 2.0 + (position.z - lookvector.z) * 2.0);
float handswalk = sin((position.x - lookvector.x) * 2.0 + (position.z - lookvector.z)) * .5;
pos.yz -= vec2(.2, .4);
 float body = max(inrect(pos.yz, -1.5 + footwalk*.4, -0.25, 0.75, .1, focus), inrect(pos.yz, -1.5 - footwalk*.4, -.1, 0.75, 0.25, focus));
 float hands = max(inrect(pos.yz, -0.5 + footwalk * .1, -0.5, 0.25, .1, focus), inrect(pos.yz, -0.5 - footwalk * 0.1, -.1, 0.25, 0.5, focus));
 return min(1.0, max(body, hands)) * factor;
}

vec4 pSdL(vec2 uvl){
  vec4 dL = dLight(uvl);
  vec4 pS = texture2D( TEXTURE_1, vec2( uvl.x, uvl.y - pShadow() * .4 ));

  vec4 setLightWorld = mix( dL, pS, max((uv1.y-.8) * 5., 0.) );
  setLightWorld = mix(
      setLightWorld, dL, 
      max( deteksi.hujan, deteksi.malam )
  );
  return setLightWorld;
}


highp float cos_between_vecs(highp vec3 v1, highp vec3 v2){
 return (v1.x * v2.x + v1.y * v2.y + v1.z * v2.z) / length(v1) / length(v2);
}

float randff(highp float n){
 return fract(cos(n) * 3800.);
}

highp float smoothrand( highp float pos){
 float start = floor(pos);
 float smoothy = smoothstep(0.0, 1.0, fract(pos));
 return mix(randff(start), randff(start + 1.0), smoothy);}

highp float smoothrand2d(highp float horizont, highp float forward){
 float start = floor(forward);
 float smoothy = smoothstep(0.0, 1.0, fract(forward));
 return mix(smoothrand(horizont + randff(start) * 1000.0), smoothrand(horizont + randff(start + 1.0) * 1000.0), smoothy);
}

highp float CheapWaterMap(highp vec3 pos, float t){
pos.z += TIME * 0.6;
 float wave1 = smoothrand2d( pos.z + pos.x, pos.z*2.);
 float wave2 = sin(wave1) * 0.5 + 0.5;
float interp = sin(TIME * t + length(pos.zx*.5)) * sin(pos.z);
 return mix(wave1, wave2, interp);
}

highp float WaterNormalMap(highp vec3 pos){
  pos = pos.zyx;
 float s = 5. + deteksi.hujan * 2.;
 return -(CheapWaterMap(pos + vec3(0.0, 0.0, 0.1), s) - CheapWaterMap(pos, s));
}

highp float WaterNormalMap(highp vec3 pos, float t){
  pos = pos.zyx;
 float s = 5. + t * 2.;
 return -(CheapWaterMap(pos + vec3(0.0, 0.0, 0.1), s) - CheapWaterMap(pos, s));
}

float rSun()
{
if ( deteksi.malam >= .05 && deteksi.malam <= .5 ){
float pagi = 1. -abs( (deteksi.malam - .05) * 4.222 -1.);
vec3 np = normalize(look);
float sun = (.6-length(np.yz));
vec3 Pos = vec3(smoothstep(7.5 + abs(np.y)*2.0,0.0,abs(np.z)*.9));
vec3 flatRange = vec3(max(0.0,sun));
float specularFlat = max(dot(Pos, flatRange), 0.0);
return specularFlat * pagi * min( .3, deteksi.nolight );
}
return 0.;
}


